Advanced Timeline in JavaScript

Using ApexCharts with JavaScript

This Advanced Timeline example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      name: 'Alice',
      data: [
        {
          x: 'Design',
          y: [
            new Date('2024-03-05').getTime(),
            new Date('2024-03-08').getTime(),
          ],
        },
        {
          x: 'Code',
          y: [
            new Date('2024-03-02').getTime(),
            new Date('2024-03-05').getTime(),
          ],
        },
        {
          x: 'Code',
          y: [
            new Date('2024-03-05').getTime(),
            new Date('2024-03-07').getTime(),
          ],
        },
        {
          x: 'Test',
          y: [
            new Date('2024-03-03').getTime(),
            new Date('2024-03-09').getTime(),
          ],
        },
        {
          x: 'Test',
          y: [
            new Date('2024-03-08').getTime(),
            new Date('2024-03-11').getTime(),
          ],
        },
        {
          x: 'Validation',
          y: [
            new Date('2024-03-11').getTime(),
            new Date('2024-03-16').getTime(),
          ],
        },
        {
          x: 'Design',
          y: [
            new Date('2024-03-01').getTime(),
            new Date('2024-03-03').getTime(),
          ],
        },
      ],
    },
    {
      name: 'Ravi',
      data: [
        {
          x: 'Design',
          y: [
            new Date('2024-03-02').getTime(),
            new Date('2024-03-05').getTime(),
          ],
        },
        {
          x: 'Test',
          y: [
            new Date('2024-03-06').getTime(),
            new Date('2024-03-16').getTime(),
          ],
          goals: [
            {
              name: 'Break',
              value: new Date('2024-03-10').getTime(),
              strokeColor: '#CD2F2A',
            },
          ],
        },
        {
          x: 'Code',
          y: [
            new Date('2024-03-03').getTime(),
            new Date('2024-03-07').getTime(),
          ],
        },
        {
          x: 'Deployment',
          y: [
            new Date('2024-03-20').getTime(),
            new Date('2024-03-22').getTime(),
          ],
        },
        {
          x: 'Design',
          y: [
            new Date('2024-03-10').getTime(),
            new Date('2024-03-16').getTime(),
          ],
        },
      ],
    },
    {
      name: 'Mia',
      data: [
        {
          x: 'Code',
          y: [
            new Date('2024-03-10').getTime(),
            new Date('2024-03-17').getTime(),
          ],
        },
        {
          x: 'Validation',
          y: [
            new Date('2024-03-05').getTime(),
            new Date('2024-03-09').getTime(),
          ],
          goals: [
            {
              name: 'Break',
              value: new Date('2024-03-07').getTime(),
              strokeColor: '#CD2F2A',
            },
          ],
        },
      ],
    },
  ],
  chart: {
    height: 450,
    type: 'rangeBar',
  },
  title: {
    text: 'Sprint Schedule by Team Member',
  },
  plotOptions: {
    bar: {
      horizontal: true,
      barHeight: '80%',
    },
  },
  xaxis: {
    type: 'datetime',
  },
  stroke: {
    width: 1,
  },
  fill: {
    type: 'solid',
    opacity: 0.6,
  },
  legend: {
    position: 'top',
    horizontalAlign: 'left',
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Advanced Timeline in React

Using ApexCharts with React

This Advanced Timeline example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Alice',
        data: [
          {
            x: 'Design',
            y: [
              new Date('2024-03-05').getTime(),
              new Date('2024-03-08').getTime(),
            ],
          },
          {
            x: 'Code',
            y: [
              new Date('2024-03-02').getTime(),
              new Date('2024-03-05').getTime(),
            ],
          },
          {
            x: 'Code',
            y: [
              new Date('2024-03-05').getTime(),
              new Date('2024-03-07').getTime(),
            ],
          },
          {
            x: 'Test',
            y: [
              new Date('2024-03-03').getTime(),
              new Date('2024-03-09').getTime(),
            ],
          },
          {
            x: 'Test',
            y: [
              new Date('2024-03-08').getTime(),
              new Date('2024-03-11').getTime(),
            ],
          },
          {
            x: 'Validation',
            y: [
              new Date('2024-03-11').getTime(),
              new Date('2024-03-16').getTime(),
            ],
          },
          {
            x: 'Design',
            y: [
              new Date('2024-03-01').getTime(),
              new Date('2024-03-03').getTime(),
            ],
          },
        ],
      },
      {
        name: 'Ravi',
        data: [
          {
            x: 'Design',
            y: [
              new Date('2024-03-02').getTime(),
              new Date('2024-03-05').getTime(),
            ],
          },
          {
            x: 'Test',
            y: [
              new Date('2024-03-06').getTime(),
              new Date('2024-03-16').getTime(),
            ],
            goals: [
              {
                name: 'Break',
                value: new Date('2024-03-10').getTime(),
                strokeColor: '#CD2F2A',
              },
            ],
          },
          {
            x: 'Code',
            y: [
              new Date('2024-03-03').getTime(),
              new Date('2024-03-07').getTime(),
            ],
          },
          {
            x: 'Deployment',
            y: [
              new Date('2024-03-20').getTime(),
              new Date('2024-03-22').getTime(),
            ],
          },
          {
            x: 'Design',
            y: [
              new Date('2024-03-10').getTime(),
              new Date('2024-03-16').getTime(),
            ],
          },
        ],
      },
      {
        name: 'Mia',
        data: [
          {
            x: 'Code',
            y: [
              new Date('2024-03-10').getTime(),
              new Date('2024-03-17').getTime(),
            ],
          },
          {
            x: 'Validation',
            y: [
              new Date('2024-03-05').getTime(),
              new Date('2024-03-09').getTime(),
            ],
            goals: [
              {
                name: 'Break',
                value: new Date('2024-03-07').getTime(),
                strokeColor: '#CD2F2A',
              },
            ],
          },
        ],
      },
    ],
    options: {
      chart: {
        height: 450,
        type: 'rangeBar',
      },
      title: {
        text: 'Sprint Schedule by Team Member',
      },
      plotOptions: {
        bar: {
          horizontal: true,
          barHeight: '80%',
        },
      },
      xaxis: {
        type: 'datetime',
      },
      stroke: {
        width: 1,
      },
      fill: {
        type: 'solid',
        opacity: 0.6,
      },
      legend: {
        position: 'top',
        horizontalAlign: 'left',
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="rangeBar"
          height={450}
        />
      </div>
    </div>
  )
}

export default ApexChart

Advanced Timeline in Angular

Using ApexCharts with Angular

This Advanced Timeline example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Alice',
              data: [
                {
                  x: 'Design',
                  y: [
                    new Date('2024-03-05').getTime(),
                    new Date('2024-03-08').getTime(),
                  ],
                },
                {
                  x: 'Code',
                  y: [
                    new Date('2024-03-02').getTime(),
                    new Date('2024-03-05').getTime(),
                  ],
                },
                {
                  x: 'Code',
                  y: [
                    new Date('2024-03-05').getTime(),
                    new Date('2024-03-07').getTime(),
                  ],
                },
                {
                  x: 'Test',
                  y: [
                    new Date('2024-03-03').getTime(),
                    new Date('2024-03-09').getTime(),
                  ],
                },
                {
                  x: 'Test',
                  y: [
                    new Date('2024-03-08').getTime(),
                    new Date('2024-03-11').getTime(),
                  ],
                },
                {
                  x: 'Validation',
                  y: [
                    new Date('2024-03-11').getTime(),
                    new Date('2024-03-16').getTime(),
                  ],
                },
                {
                  x: 'Design',
                  y: [
                    new Date('2024-03-01').getTime(),
                    new Date('2024-03-03').getTime(),
                  ],
                },
              ],
            },
            {
              name: 'Ravi',
              data: [
                {
                  x: 'Design',
                  y: [
                    new Date('2024-03-02').getTime(),
                    new Date('2024-03-05').getTime(),
                  ],
                },
                {
                  x: 'Test',
                  y: [
                    new Date('2024-03-06').getTime(),
                    new Date('2024-03-16').getTime(),
                  ],
                  goals: [
                    {
                      name: 'Break',
                      value: new Date('2024-03-10').getTime(),
                      strokeColor: '#CD2F2A',
                    },
                  ],
                },
                {
                  x: 'Code',
                  y: [
                    new Date('2024-03-03').getTime(),
                    new Date('2024-03-07').getTime(),
                  ],
                },
                {
                  x: 'Deployment',
                  y: [
                    new Date('2024-03-20').getTime(),
                    new Date('2024-03-22').getTime(),
                  ],
                },
                {
                  x: 'Design',
                  y: [
                    new Date('2024-03-10').getTime(),
                    new Date('2024-03-16').getTime(),
                  ],
                },
              ],
            },
            {
              name: 'Mia',
              data: [
                {
                  x: 'Code',
                  y: [
                    new Date('2024-03-10').getTime(),
                    new Date('2024-03-17').getTime(),
                  ],
                },
                {
                  x: 'Validation',
                  y: [
                    new Date('2024-03-05').getTime(),
                    new Date('2024-03-09').getTime(),
                  ],
                  goals: [
                    {
                      name: 'Break',
                      value: new Date('2024-03-07').getTime(),
                      strokeColor: '#CD2F2A',
                    },
                  ],
                },
              ],
            },
          ],
          chart: {
            height: 450,
            type: 'rangeBar',
          },
          title: {
            text: 'Sprint Schedule by Team Member',
          },
          plotOptions: {
            bar: {
              horizontal: true,
              barHeight: '80%',
            },
          },
          xaxis: {
            type: 'datetime',
          },
          stroke: {
            width: 1,
          },
          fill: {
            type: 'solid',
            opacity: 0.6,
          },
          legend: {
            position: 'top',
            horizontalAlign: 'left',
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Advanced Timeline in Vue

Using ApexCharts with Vue

This Advanced Timeline example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="rangeBar"
        height="450"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Alice',
          data: [
            {
              x: 'Design',
              y: [
                new Date('2024-03-05').getTime(),
                new Date('2024-03-08').getTime(),
              ],
            },
            {
              x: 'Code',
              y: [
                new Date('2024-03-02').getTime(),
                new Date('2024-03-05').getTime(),
              ],
            },
            {
              x: 'Code',
              y: [
                new Date('2024-03-05').getTime(),
                new Date('2024-03-07').getTime(),
              ],
            },
            {
              x: 'Test',
              y: [
                new Date('2024-03-03').getTime(),
                new Date('2024-03-09').getTime(),
              ],
            },
            {
              x: 'Test',
              y: [
                new Date('2024-03-08').getTime(),
                new Date('2024-03-11').getTime(),
              ],
            },
            {
              x: 'Validation',
              y: [
                new Date('2024-03-11').getTime(),
                new Date('2024-03-16').getTime(),
              ],
            },
            {
              x: 'Design',
              y: [
                new Date('2024-03-01').getTime(),
                new Date('2024-03-03').getTime(),
              ],
            },
          ],
        },
        {
          name: 'Ravi',
          data: [
            {
              x: 'Design',
              y: [
                new Date('2024-03-02').getTime(),
                new Date('2024-03-05').getTime(),
              ],
            },
            {
              x: 'Test',
              y: [
                new Date('2024-03-06').getTime(),
                new Date('2024-03-16').getTime(),
              ],
              goals: [
                {
                  name: 'Break',
                  value: new Date('2024-03-10').getTime(),
                  strokeColor: '#CD2F2A',
                },
              ],
            },
            {
              x: 'Code',
              y: [
                new Date('2024-03-03').getTime(),
                new Date('2024-03-07').getTime(),
              ],
            },
            {
              x: 'Deployment',
              y: [
                new Date('2024-03-20').getTime(),
                new Date('2024-03-22').getTime(),
              ],
            },
            {
              x: 'Design',
              y: [
                new Date('2024-03-10').getTime(),
                new Date('2024-03-16').getTime(),
              ],
            },
          ],
        },
        {
          name: 'Mia',
          data: [
            {
              x: 'Code',
              y: [
                new Date('2024-03-10').getTime(),
                new Date('2024-03-17').getTime(),
              ],
            },
            {
              x: 'Validation',
              y: [
                new Date('2024-03-05').getTime(),
                new Date('2024-03-09').getTime(),
              ],
              goals: [
                {
                  name: 'Break',
                  value: new Date('2024-03-07').getTime(),
                  strokeColor: '#CD2F2A',
                },
              ],
            },
          ],
        },
      ],
      chartOptions: {
        chart: {
          height: 450,
          type: 'rangeBar',
        },
        title: {
          text: 'Sprint Schedule by Team Member',
        },
        plotOptions: {
          bar: {
            horizontal: true,
            barHeight: '80%',
          },
        },
        xaxis: {
          type: 'datetime',
        },
        stroke: {
          width: 1,
        },
        fill: {
          type: 'solid',
          opacity: 0.6,
        },
        legend: {
          position: 'top',
          horizontalAlign: 'left',
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}

.apexcharts-yaxis text {
  font-weight: bold;
}
</style>